SystemOrganization addCategory: #'SOUL-EvalPrintLoop'!

Object subclass: #Binding
	instanceVariableNames: 'var value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-EvalPrintLoop'!

!Binding class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
var: aVar value: aValue
	
	^self new setVar: aVar setValue: aValue! !

!Binding methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	var printOn: aStream.
	aStream write: '-->'.
	value class == Environment
		ifTrue: [aStream write: '**env**']
		ifFalse: [value printOn: aStream]! !

!Binding methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
setVar: aQSOULVariable setValue: aQSOULAbstractTerm
	
	var := aQSOULVariable.
	value := aQSOULAbstractTerm! !

!Binding methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
value
	
	^value! !

!Binding methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
variable
	
	^var! !

Object subclass: #EmptyEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-EvalPrintLoop'!

!EmptyEvaluator methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
allResults
	
	^Results new timeTaken: 42! !

!EmptyEvaluator methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
lastResult
	
	^self allResults! !

!EmptyEvaluator methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
nextResult
	
	^self allResults! !

!EmptyEvaluator methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
results
	
	^self allResults! !

Object subclass: #GraphExport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-EvalPrintLoop'!

!GraphExport class methodsFor: 'nodes and edges' stamp: 'sp 24/10/11 15:26'!
changeMultiplicityOf: aNodeOrEdgeString to: aNumber
	"The multiplicity is assumed to be the last argument of the node(type,name,multiplicity) or edge(type,source,target,multiplicity), and can be found by looking for the last comma in the string."

	
	^aNodeOrEdgeString
		changeFrom:
			(aNodeOrEdgeString
				findPreviousString: ','
				startingAt: aNodeOrEdgeString size) + 1
		to: aNodeOrEdgeString size - 1
		with: aNumber asString! !

!GraphExport class methodsFor: 'nodes and edges' stamp: 'sp 24/10/11 15:26'!
edgeWithType: aTypeString withSource: aSourceString withTarget: aTargetString
	"implemented by Tom Mens to visualise and reason about the evolution of Soul predicates"

	"last modification on 2002-03-05"

	
	^self edgeWithType: aTypeString withSource: aSourceString withTarget:
			aTargetString withMultiplicity: 1! !

!GraphExport class methodsFor: 'nodes and edges' stamp: 'sp 24/10/11 15:26'!
edgeWithType: aTypeString withSource: aSourceString withTarget: aTargetString withMultiplicity: aNumber
	"implemented by Tom Mens to visualise and reason about the evolution of Soul predicates"

	"last modification on 2002-03-05"

	
	^'edge(' , aTypeString , ',' , aSourceString , ',' , aTargetString , ','
		, aNumber asString , ')'! !

!GraphExport class methodsFor: 'nodes and edges' stamp: 'sp 24/10/11 15:26'!
nodeWithType: aTypeString withName: aNameString
	"implemented by Tom Mens to visualise and reason about the evolution of Soul predicates"

	"last modification on 2002-03-05"

	
	^self nodeWithType: aTypeString withName: aNameString withMultiplicity: 1! !

!GraphExport class methodsFor: 'nodes and edges' stamp: 'sp 24/10/11 15:26'!
nodeWithType: aTypeString withName: aNameString withMultiplicity: aNumber
	"implemented by Tom Mens to visualise and reason about the evolution of Soul predicates"

	"last modification on 2002-03-05"

	
	^'node(' , aTypeString , ',' , aNameString , ',' , aNumber asString , ')'! !

!GraphExport class methodsFor: 'output' stamp: 'AndyKellens 11/2/2011 09:53'!
saveRepositoryToFile: fileName
	
	| writeBlock aStream rep clauseNodes clauseUses clauseUsesWithMultiplicity elt |
	rep := SoulFactory logicRepository.
	clauseNodes := OrderedCollection new.
	clauseUses := OrderedCollection new.
	rep collectClauses: clauseNodes andUses: clauseUses.	"Replace duplicate edges in clauseUses by a single edge that mentions its multiplicity"

	clauseUsesWithMultiplicity := OrderedCollection new.
	clauseUses
		do:
			[:aNode | 
			elt := GraphExport
				changeMultiplicityOf: aNode
				to: (clauseUses occurrencesOf: aNode).
			(clauseUsesWithMultiplicity includes: elt)
				ifFalse: [clauseUsesWithMultiplicity add: elt]].
	aStream := fileName asFilename writeStream.
	writeBlock := ["First output some comments"

	aStream
		nextPutAll:
				'"List of all repositories and clauses in Soul 2.7.0 Licor 2.7"';
		cr.
	aStream
		nextPutAll: '"Generated on ' , Time dateAndTimeNow asString , '"';
		cr.	"Then write the nodes of the graph on file"

	rep collectRepositoryNodes
		do:
			[:eltx | 
			elt := eltx.
			aStream
				nextPutAll: elt;
				cr].
	clauseNodes
		do:
			[:eltx | 
			elt := eltx.
			aStream
				nextPutAll: elt;
				cr].	"Next write the edges of the graph on file"

	rep collectRepositoryContainments
		do:
			[:eltx | 
			elt := eltx.
			aStream
				nextPutAll: elt;
				cr].
	rep collectClauseContainments
		do:
			[:eltx | 
			elt := eltx.
			aStream
				nextPutAll: elt;
				cr].
	clauseUsesWithMultiplicity
		do:
			[:eltx | 
			elt := eltx.
			aStream
				nextPutAll: elt;
				cr]].
	[writeBlock value] valueNowOrOnUnwindDo: [aStream close]! !

Object subclass: #Results
	instanceVariableNames: 'results query timeTaken success'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-EvalPrintLoop'!

!Results class methodsFor: 'signal constants' stamp: 'sp 24/10/11 15:26'!
errorSignal
	
	^SoulError! !

!Results class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
new
	
	^super new initialize! !

!Results class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
onQuery: aQuery
	
	^self new query: aQuery! !

!Results methodsFor: 'private-access' stamp: 'sp 24/10/11 15:26'!
add: aCollectionOfBindings
	
	| coll |
	aCollectionOfBindings ~~ false
		ifTrue:
			[self success: true.
			aCollectionOfBindings
				do:
					[:aBinding | 
					| var |
					var := aBinding variable.
					var isHiddenVariable
						ifFalse:
							[coll := results
								at: var
								ifAbsentPut: [OrderedCollection new].
							coll add: aBinding value]]].
	self changed: #add:! !

!Results methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
basicResultText
	
	| stream |
	stream := WriteStream on: String new.
	self printBasicInformationOn: stream.
	^stream contents! !

!Results methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
displayString
	
	^self basicResultText! !

!Results methodsFor: 'public-enumerating' stamp: 'sp 24/10/11 15:26'!
do: aBlock
	"Enumerate over the results. aBlock is a smalltalkblock that must have 1  
	parameter, which will be bound to a Collection of Binding, for  
	each subsequent result"

	
	1
		to: self size
		do:
			[:index | 
			| collect |
			collect := OrderedCollection new.
			results
				keysAndValuesDo:
					[:key :value | 
					collect
						add:
							(Binding
								var: key
								value: (value at: index))].
			aBlock value: collect]! !

!Results methodsFor: 'public-enumerating' stamp: 'sp 24/10/11 15:26'!
do: aBlock forVariableNames: aCollectionOfVariableNames
	"Enumerate over the results but only consider the results of some  
	variables. aBlock is a smalltalkblock that must have as many  
	parameters as the number of variables. The parameters will be bound  
	to a their value, for each subsequent result"

	
	self
		do: aBlock
		forVariables:
			(aCollectionOfVariableNames
				collect:
					[:each | 
					| temp |
					results keys do: [:key | key name = each ifTrue: [temp := key]].
					temp])! !

!Results methodsFor: 'public-enumerating' stamp: 'sp 24/10/11 15:26'!
do: aBlock forVariables: aCollectionOfVariables
	"Enumerate over the results but only consider the results of some  
	variables. aBlock is a smalltalkblock that must have as many  
	parameters as the number of variables. The parameters will be bound  
	to a their value, for each subsequent result"

	
	1
		to: self size
		do:
			[:index | 
			aBlock
				valueWithArguments:
					(aCollectionOfVariables collect: [:var | (results at: var) at: index])
						asArray]! !

!Results methodsFor: 'public-enumerating' stamp: 'sp 24/10/11 15:26'!
doCollection: aBlock forVariableNames: aCollectionOfVariableNames
	"Enumerate over the results but only consider the results of some  
	variables. aBlock is a smalltalkblock that must have 1 parameter, which will be bound to a collection of values for the variables named"

	
	self
		doCollection: aBlock
		forVariables:
			(aCollectionOfVariableNames
				collect:
					[:each | 
					| temp |
					results keys do: [:key | key name = each ifTrue: [temp := key]].
					temp])! !

!Results methodsFor: 'public-enumerating' stamp: 'sp 24/10/11 15:26'!
doCollection: aBlock forVariables: aCollectionOfVariables
	"Enumerate over the results but only consider the results of some  
	variables. aBlock is a smalltalkblock that must have 1 paramater. The parameter will be bound  
	to a collection of values for the variables"

	
	1
		to: self size
		do:
			[:index | 
			aBlock
				value:
					(aCollectionOfVariables collect: [:var | (results at: var) at: index])
						asArray]! !

!Results methodsFor: 'public-access' stamp: 'sp 24/10/11 15:26'!
downedResultsForVariableNamed: aString
	
	^(self resultsForVariableNamed: aString)
		collect:
			[:each | 
			each
				soulDownIn: Environment new
				startAt: 0]! !

!Results methodsFor: 'public-access' stamp: 'sp 24/10/11 15:26'!
fails
	"Did the query fail?"

	
	^success not! !

!Results methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
initialize
	
	results := Dictionary new.
	self success: false.
	timeTaken := 0! !

!Results methodsFor: 'public-access' stamp: 'sp 24/10/11 15:26'!
isEmpty
	"Is the set of results empty?"

	
	^results isEmpty! !

!Results methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printBasicInformationOn: aStream
	
	results isEmpty
		ifTrue:
			[aStream write: '['.
			self success printOn: aStream.
			aStream write: ']']
		ifFalse:
			[| keys values |
			keys := OrderedCollection new.
			values := OrderedCollection new.
			results
				keysAndValuesDo:
					[:key :value | 
					keys add: key.
					values add: value].
			1
				to: self size
				do:
					[:resultIndex | 
					| keyIndex |
					aStream write: '['.
					keyIndex := 1.
					keys
						do:
							[:key | 
							(Binding
								var: key
								value: ((values at: keyIndex) at: resultIndex)) printOn: aStream.
							keyIndex := keyIndex + 1]
						separatedBy:
							[aStream
								write: ',';
								cr].
					aStream
						write: ']';
						cr;
						cr]]! !

!Results methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	aStream
		write: 'SOUL found';
		cr;
		write:
				self size asString , ' solutions in ' , timeTaken asString , ' ms for:';
		cr.
	query printOn: aStream.
	aStream
		cr;
		cr;
		cr.
	self printBasicInformationOn: aStream! !

!Results methodsFor: 'public-access' stamp: 'sp 24/10/11 15:26'!
query
	"Returns the query that was used to obtain these results"

	
	^query! !

!Results methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
query: aQuery
	
	query := aQuery! !

!Results methodsFor: 'private-access' stamp: 'sp 24/10/11 15:26'!
results
	"Implemented by Tom Mens on 2002-02-13"

	
	^results! !

!Results methodsFor: 'public-access' stamp: 'sp 24/10/11 15:26'!
resultsForVariableNamed: aString
	
	^self success
		ifTrue: [self results at: (self variableNamed: aString)]
		ifFalse: [#()]! !

!Results methodsFor: 'public-access' stamp: 'sp 24/10/11 15:26'!
size
	"Returns the number of results"

	
	^results isEmpty
		ifTrue: [0]
		ifFalse: [results associations first value size]! !

!Results methodsFor: 'public-access' stamp: 'sp 24/10/11 15:26'!
success
	"Is the query succesfull?"

	
	^success! !

!Results methodsFor: 'private-access' stamp: 'sp 24/10/11 15:26'!
success: aBoolean
	
	success := aBoolean! !

!Results methodsFor: 'public-access' stamp: 'sp 24/10/11 15:26'!
timeTaken
	"Returns the time in milliseconds that was required to obtain these 
	results "

	
	^timeTaken! !

!Results methodsFor: 'private-access' stamp: 'sp 24/10/11 15:26'!
timeTaken: aTime
	
	timeTaken := aTime! !

!Results methodsFor: 'public-access' stamp: 'sp 24/10/11 15:26'!
variableNamed: aString
	
	^self variables
		detect: [:keyVar | keyVar name = aString]
		ifNone:
			[self
				error:
					'Variable ''?' , aString , ''' not found in query: '''
						, self query printString , '''']! !

!Results methodsFor: 'public-access' stamp: 'sp 24/10/11 15:26'!
variables
	"returns the variables that these results are about. Return the keys in the results dictionary, since they contain the actual variables used. This method used to return the variables used by the query, but these are other variables. "

	
	^self results keys! !

Object subclass: #SoulEvaluator
	instanceVariableNames: 'ruleselector query allResults lastResultCollection lastTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-EvalPrintLoop'!

!SoulEvaluator class methodsFor: 'configuration' stamp: 'AndyKellens 11/2/2011 09:53'!
associatedFactory
	
	^StandardSoulFactory! !

!SoulEvaluator class methodsFor: 'configuration' stamp: 'sp 24/10/11 15:26'!
canBeConfigured
	
	^false! !

!SoulEvaluator class methodsFor: 'configuration' stamp: 'sp 24/10/11 15:26'!
configureFactory
	
	^self associatedFactory install! !

!SoulEvaluator class methodsFor: 'signal constants' stamp: 'sp 24/10/11 15:26'!
errorSignal
	
	^SoulParseError! !

!SoulEvaluator class methodsFor: 'instance creation' stamp: 'AndyKellens 11/2/2011 09:53'!
eval: aQueryText
	"Evaluate the query in the default repository when none was specified."

	
	^self
		eval: aQueryText
		in: SoulFactory logicRepository
		withAssociations: #()! !

!SoulEvaluator class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
eval: aQueryText in: aRepository
	
	^self eval: aQueryText in: aRepository withAssociations: #() notifying:
			nil! !

!SoulEvaluator class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
eval: aQueryText in: aRepository notifying: aTextController
	
	^self eval: aQueryText in: aRepository withAssociations: #() notifying:
			aTextController! !

!SoulEvaluator class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
eval: aQueryText in: aRepository withAssociations: aCollection
	
	^self eval: aQueryText in: aRepository withAssociations: aCollection
		notifying: nil! !

!SoulEvaluator class methodsFor: 'instance creation' stamp: 'AndyKellens 11/2/2011 09:53'!
eval: aQueryText in: aRepository withAssociations: aCollection notifying: aTextController
	
	| parser query |
	self configureFactory.
	parser := SoulFactory current makeParser.
	aTextController isNil
		ifTrue:
			[query := parser
				parse: aQueryText
				onError:
					[:text :pos | self error: 'Parser error: ' , text , 'at: ' , pos asString]]
		ifFalse:
			[query := parser
				parse: aQueryText
				onError:
					[:text :pos | 
					aTextController
						insertAndSelect: '<-' , text
						at: pos.
					aTextController activate.
					^EmptyEvaluator new]].
	query species == SoulFactory current makeQuery
		ifFalse:
			[Error
				raiseSignal:
					'Evaluator input is not a query (missing ''if'' ?): ' , aQueryText].
	^self evalQuery: query in: aRepository withAssociations: aCollection! !

!SoulEvaluator class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
eval: aQueryText in: aRepository withAssociations: aCollection reportingProgressFor: aLabelText
	
	^self eval: aQueryText in: aRepository withAssociations: aCollection
		reportingProgressFor: aLabelText notifying: nil! !

!SoulEvaluator class methodsFor: 'instance creation' stamp: 'AndyKellens 11/2/2011 09:53'!
eval: aQueryText in: aRepository withAssociations: aCollection reportingProgressFor: aLabelText notifying: aTextController
	
	| sel parser query newQueryText |
	(aCollection isEmpty
		or: [(aCollection first value isKindOf: Collection) not])
		ifTrue:
			[^self eval: aQueryText in: aRepository withAssociations: aCollection
				notifying: aTextController].
	sel := SoulFactory current makeRuleSelector new.
	parser := SoulFactory current makeParser.
	newQueryText := 'if [?counter value: ?counter value + 1. ?model value: ?counter value / '
		, aCollection first value size asString ,
			'. (?model value = 1) ifTrue:[?controller closeAndUnschedule]. true],'
		, (aQueryText allButFirst: 3).
	aTextController isNil
		ifTrue:
			[query := parser
				parse: newQueryText
				onError:
					[:text :pos | self error: 'Parser error: ' , text , 'at: ' , pos asString]]
		ifFalse:
			[query := parser
				parse: newQueryText
				onError:
					[:text :pos | 
					aTextController
						insertAndSelect: '<-' , text
						at: pos.
					aTextController activate.
					^EmptyEvaluator new]].
	query species == SoulFactory current makeQuery
		ifFalse:
			[Error
				raiseSignal:
					'Evaluator input is not a query (missing ''if'' ?): ' , aQueryText].
	query addConditionsInFront: (self makeEquals: aCollection).
	query
		addConditionsInFront:
			(parser
				parse:
					'if equals(?counter,[0 asValue]),equals(?model,[model := 0.0 asValue]),equals(?controller,[
			    ProgressWidgetView progressOpenOn: ?model
				label: ' , aLabelText printString , ' asText allBold])') condition
				terms.
	query definitionRepository: aRepository.
	self prepareDefinitionRepositoryOfQuery: query.
	sel evalQuery: query.
	^(self new)
		ruleselector: sel;
		query: query! !

!SoulEvaluator class methodsFor: 'instance creation' stamp: 'AndyKellens 11/2/2011 09:53'!
eval: aQueryText withAssociations: aCollection
	"Evaluate the query in the default repository when none was specified."

	
	^self
		eval: aQueryText
		in: SoulFactory logicRepository
		withAssociations: aCollection! !

!SoulEvaluator class methodsFor: 'instance creation' stamp: 'AndyKellens 11/2/2011 09:53'!
evalQuery: query in: repository
	
	| selector |
	query definitionRepository: repository.
	selector := (SoulFactory current makeRuleSelector new)
		evalQuery: query;
		yourself.
	^(self new)
		ruleselector: selector;
		query: query! !

!SoulEvaluator class methodsFor: 'instance creation' stamp: 'AndyKellens 11/2/2011 09:53'!
evalQuery: aQuery in: aRepository withAssociations: aCollection
	
	| sel |
	self configureFactory.
	sel := SoulFactory current makeRuleSelector new.
	aQuery addConditionsInFront: (self makeEquals: aCollection).
	aQuery definitionRepository: aRepository.
	self prepareDefinitionRepositoryOfQuery: aQuery.
	sel evalQuery: aQuery.
	^(self new)
		ruleselector: sel;
		query: aQuery! !

!SoulEvaluator class methodsFor: 'private' stamp: 'AndyKellens 11/2/2011 09:53'!
makeEquals: aCollection
	
	| result var val terms equals |
	result := OrderedCollection new.
	aCollection
		do:
			[:varvalue | 
			| functorname |
			var := SoulFactory current makeVariable name: varvalue key asString.	"WARNING: the implementation of this method changed to invoke the parser because a bug occurred when the values are soul terms extracted from other terms. Since these will again be passing through the variable indexer and break the entire variable-indexing mechanism. Passing everything through the parser ensures making a unique copy that can be cleaned on its own"

			((varvalue value isKindOf: AbstractTerm)
				and: [(varvalue value isKindOf: UppedObject) not])
				ifTrue:
					[| copying "[val := (SoulParser parse: varvalue value displayString) terms first
						conclusion]"
 |
					copying := CopyingVisitor new.
					val := varvalue value accept: copying]
				ifFalse: [val := varvalue value soulUp].
			functorname := (varvalue value isMemberOf: OrderedCollection)
				ifTrue: [#member]
				ifFalse: [#equals].
			terms := OrderedCollection new.
			terms add: var.
			terms add: val.
			equals := SoulFactory current makeCompound
				functor: (Constant name: functorname)
				termSequence: (TermSequence terms: terms).
			result add: equals].
	^result! !

!SoulEvaluator class methodsFor: 'configuration' stamp: 'sp 24/10/11 15:26'!
openConfigurationWindow
	
	! !

!SoulEvaluator class methodsFor: 'private' stamp: 'AndyKellens 10/28/2011 16:04'!
prepareDefinitionRepositoryOfQuery: aQuery
	
	aQuery definitionRepository
		additionalClausesToBeAdded:
			aQuery additionalClausesForDefinitionRepository.
	aQuery definitionRepository compile! !

!SoulEvaluator methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
allResults
	
	allResults
		timeTaken:
			(lastTime := Time
				millisecondsToRun:
					[[(lastResultCollection := ruleselector next) == false]
						whileFalse: [allResults add: lastResultCollection].
					allResults isEmpty ifTrue: [allResults add: lastResultCollection]])
				+ allResults timeTaken.
	^allResults! !

!SoulEvaluator methodsFor: 'private' stamp: 'AndyKellens 11/2/2011 09:53'!
lastResult
	
	| results |
	results := SoulFactory current makeResults onQuery: query.
	results add: lastResultCollection.
	^results! !

!SoulEvaluator methodsFor: 'evaluation' stamp: 'AndyKellens 11/2/2011 09:53'!
nextResult
	
	| result |
	result := SoulFactory current makeResults onQuery: query.
	result
		timeTaken:
			(Time millisecondsToRun: [lastResultCollection := ruleselector next]).
	result add: lastResultCollection.
	allResults add: lastResultCollection.
	allResults timeTaken: result timeTaken + allResults timeTaken.
	^result! !

!SoulEvaluator methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
query
	
	^query! !

!SoulEvaluator methodsFor: 'initialize' stamp: 'AndyKellens 11/2/2011 09:53'!
query: aQuery
	
	query := aQuery.
	allResults := SoulFactory current makeResults onQuery: query! !

!SoulEvaluator methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
results
	
	^allResults! !

!SoulEvaluator methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
ruleselector
	
	^ruleselector! !

!SoulEvaluator methodsFor: 'initialize' stamp: 'AndyKellens 10/28/2011 17:04'!
ruleselector: sel
	
	ruleselector := sel ! !
